'Egy BASIC mintaprogram a PICPLC1 panelre.
'stip/dir lptet motor meghajt panel vezrlse

'Config - fuse bit - bellts
'A proci beptett rajelgenertort hasznlom - INTOSC - s kdvdelem - CP - kikapcsolva
'A PLL rajel ngyszerez, s az alacsonyfeszltsg programozs - LVP - kikapcsolva. 
#CONFIG             
    __config _CONFIG1, _FOSC_INTOSC & _CP_OFF
    __config _CONFIG2, _PLLEN_ON & _LVP_OFF 
#endCONFIG

'    OSCCON = %01101010   ' Belltom 4 megra a bels rajelet
'    OSCCON = %01111010   ' Belltom 16 megra a bels rajelet
    OSCCON = %11110000   ' Belltom 32 megra a bels rajelet    
    
    DEFINE OSC 32
    
' Akr 14 lb hasznlhat analg bemenetnek, de most minden lbat digitlis portnak akarunk.

   ANSELA = %00000000    ' porta mind digitlis
   ANSELB = %00000000    ' portb mind digitlis
   ANSELD = %00000000    ' portd mind digitlis
   ANSELE = %00000000    ' porte mind digitlis
    
	ADCON1 = %00000110	' Az ADCON1 regiszter 
  
    
 ' OPTION_REG 7. = 0 bels felhzk engedlyezve, 6. = 1 felfut l, 5.=0 forrs fosc/4, 4. = 0, 3.= 1 eloszt kikapcsolva, 2.-1.-0. elszt  
   '              76543210   		
'    OPTION_REG = %01011000			
    OPTION_REG = %01010011  ' 16-os oszts    
' INTCON: 7.ltalnos megszakts engedlyezs, 6.perifria megszakts tiltva, 5.=1 timer0 tlcsorduls megszakts engedlyezve   
'             76543210
    INTCON = %10100000 			
 
      On Interrupt Goto tickint
       
'Elszr is kzljk a programmal, hol tallja az LCD-t, es hogyan akarjuk vezrelni:
 
	DEFINE LCD_DREG 	PORTD ' Az LCD adatvezetket a D portrol vezreljk
	DEFINE LCD_DBIT 	0	' Az els adatvezetk az RD port 0. tagja. (Az RD0)
	DEFINE LCD_RSREG 	PORTD ' Az LCD Register Select kivezetse a D portra csatlakozik,
	DEFINE LCD_RSBIT 	4	' mgpedig az RD4 labra. (Tehat az LCD RS - az RD4 porton van.)
	DEFINE LCD_EREG 	PORTD ' Az enable vezerl bit is a D porton,
	DEFINE LCD_EBIT 	5	' az RD5 portra van kiosztva. (LCD EN - RD5 port.)
	DEFINE LCD_BITS 	4	' a 4 bites uzemmodot vlasztjuk,
	DEFINE LCD_LINES 	2	' es 2 soros az LCD

	TRISA = %00000000	' A PORTA0-7 output
	TRISB = %00000000	' A PORTB0-7 output
	TRISC = %00111100	' A PORTC 2-5 input, a PORTC 0-1 s 6-7 output

	CLOCK VAR PORTA.0
	DIR VAR PORTA.1
    EN VAR PORTA.2
    
	K1GOMB var PORTC.2			' A K1 nyomgomb a PORTC 2-n van,
	K2GOMB var PORTC.3			' A K1 nyomgomb a PORTC 3-n van,
	K3GOMB var PORTC.4			' A K1 nyomgomb a PORTC 4-n van,
	K4GOMB var PORTC.5			' A K1 nyomgomb a PORTC 5-n van,

	PIROSLED var PORTB.7
	ZOLDLED var PORTB.6
    
	' Konfigurljuk a PORTA-t. Teht hogy melyik kivezetseket akarjuk digitlis, vagy 
	' analg portnak hasznlni. 
	' Ezeket az ADCON1 regiszterbe tlttt adat fogja meghatrozni. 
	' Szval most a PORTA0-7 mind mint digitlis port legyen hasznlva.
	

		' Helyet foglalunk a vltozoknak a mikrokontroller RAM-jaban

	SZMPDELAY var Byte
   	PARAM var word
    STEPTIME var word   
    LEPTETOIMPPARAM var byte   
    TIMEPARAM var word    
   	EEPARAM var word 
    BILLPERG var Byte 
    NYOMESZ var Byte 
    BEMFLAG var BIT
    PERCBIT var BIT  
   	MPBIT var BIT  
   	BILLFLAG var BIT 
  	START var BIT
  	IRANY var BIT
    FRISSLCD1 var BIT   
    FRISSLCD2 var BIt    
  	ORAJEL var BIT
  	
  	PERC var Byte
    MP var Byte
    SZMP var Byte
    ora var Byte
    tiktak var Byte     
    tizesoszto var byte
    BILLTIME var BIT
    
 			

nullaz: 
    EEPROM  1,[100]
    EEPROM  2,[0]    
    READ 1,PARAM.BYTE0
    READ 2,PARAM.BYTE1
    EEPARAM = PARAM
	perc = 0  
	mp = 0
    tiktak = 0
    start = 0
    
    pause 100
    
    LCDOUT $fe,1,  "****Step/Dir****"	' LCD trles, es irs az els sorba
    LCDOUT $fe,$C0,"****PICPLC1*****"	'es iras a masodik sorba   
    pause 1500
    FRISSLCD1 = 1
    FRISSLCD2 = 1
        
main: 
      If FRISSLCD1 = 1 THEN
           LCDOUT $fe,$80,"Irany:",#IRANY," Start:",#START," " ' irs az els sorba
'           LCDOUT $fe,$80,"mp: ",dec2 mp," perc:",dec2 perc," " ' irs az els sorba           
           FRISSLCD1 = 0  'Kirtuk amit kell, a jelz bitet most mr alaphelyzetbe lltjuk                        
      endif   
      
      If FRISSLCD2 = 1 THEN   
'           LCDOUT $fe,$C0,dec5 PARAM," Fokozat  "   ' irs a msodik sorba
           LCDOUT $fe,$C0,"L.ido: 0.",dec4 PARAM," mp"   ' irs a msodik sorba
           FRISSLCD2 = 0  'Kirtuk amit kell, a jelz bitet most mr alaphelyzetbe lltjuk                        
      endif         

        NYOMESZ = 0
        IF K1GOMB = 0 THEN NYOMESZ = 1
        IF K2GOMB = 0 THEN NYOMESZ = 2
        IF K3GOMB = 0 THEN NYOMESZ = 3
        IF K4GOMB = 0 THEN NYOMESZ = 4
        
        IF NYOMESZ = 0 THEN GOTO nincsgomb
    
        
        SELECT CASE NYOMESZ        ' PORTC xxyyyyxx
                
                CASE 1             
                    goto GOMB1 
                CASE 2
                    goto GOMB2  
                CASE 3
                    goto GOMB3  
                CASE 4
                    goto GOMB4   
        end select
 
GOMB1:   
   
        If BILLFLAG = 0 THEN
            toggle START   
            EN = not START
            FRISSLCD1 = 1
                
        endif
            BILLFLAG = 1
        goto tovabb
        
' bellt men
        
                     
GOMB2:           'K2 a felfele gomb
           
            IF billtime = 1 THEN
                billtime = 0
                BILLPERG = BILLPERG + 1 
        
                IF BILLPERG = 150 THEN
                    BILLFLAG = 0
                    BILLPERG = 145
                ENDIF           
            endif
        
            If BILLFLAG = 0 THEN
                PARAM = PARAM + 1
                    if param >= 10000 then param = 5
                FRISSLCD2 = 1
  '              EEPFLAG = 1                
            ENDIF
            BILLFLAG = 1         
         goto tovabb   
         
GOMB3:      'K3 a lefele gomb
         
            IF billtime = 1 THEN
                billtime = 0
                BILLPERG = BILLPERG + 1 
        
                IF BILLPERG = 150 THEN
                    BILLFLAG = 0
                    BILLPERG = 145
                ENDIF           
            ENDIF   
         
            If BILLFLAG = 0 THEN
                PARAM = PARAM - 1
                    if param <= 4 then param = 9999
                FRISSLCD2 = 1
   '             EEPFLAG = 1
            ENDIF
            BILLFLAG = 1
         goto tovabb   
 	 
GOMB4:            

	     If BILLFLAG = 0 THEN
            TOGGLE IRANY  
            DIR = IRANY
            PIROSLED = DIR
            FRISSLCD1 = 1  
         endif
            BILLFLAG = 1
         goto tovabb
    
nincsgomb:
        BILLFLAG = 0
        BILLPERG = 0 
tovabb:
  ZOLDLED = CLOCK  
 

        IF PERCBIT = 1 THEN        ' Percenknt megcsinlja a lentieket
                IF PARAM != EEPARAM THEN    'Ha vltozott a paramter, mentjk
                    WRITE 1,PARAM.byte0
                    WRITE 2,PARAM.byte1
                    toggle PORTB.7
                    EEPARAM = PARAM
                    PAUSE 1000
                    FRISSLCD2 = 1
                ENDIF              
                PERCBIT = 0
         ENDIF
  	
  	  goto main		' Ugras a ciklus elejere, kezdodik minden ujra... 

        Disable		' Disable interrupts during interrupt handler
  	  
'Szval ha 32 megs a kvarc, akkor az fosc/4 ugye 8.000.000 Hz. Ezt osztjuk elbb 16-al, majd  50-el.
'A 16-os osztst az  OPTION_REG -ben lltottuk be, az 50-es osztst TMR0-ba tlttt 206 idzi el. Ha 50-et lp, akkor
'lesz ugye 256, amikor is "tlcsordul", s a megszaktst kr. 
'Szval 32.000.000/4/16/50 = 10.000 -szer fut msodpercenknt a lenti program rszlet.
'Vagy 0.1 millisecundumonknt, ahogy tetszik.     
'Ha itt csinlunk egy 100-as osztst, akkor van egys zzadmsodperces, s aztn mg egy 100-as oszts, 
's meg van az htott 1 msodperces idalapunk. Na teht:
   
    
tickint:   
    INTCON.2 = 0    ' Reseteljk a timer0 "tlcsorduls" megszakts jelz bitet
    TMR0 = 206
   
      tiktak = tiktak + 1    ' Minden 0.01 mS utn - szzezred msodpercenknt - eggyel n   
      steptime = steptime + 1
      LEPTETOIMPPARAM = LEPTETOIMPPARAM + 1
      if LEPTETOIMPPARAM = 3 then ORAJEL = 0
      
        if STEPTIME >= PARAM then 
            STEPTIME = 0
            orajel = 1
            LEPTETOIMPPARAM = 0          
        endif
        
        CLOCK = ORAJEL and START    
      If tiktak < 100 Then timerexit 'Ha mg nem rtk el a 100-at, kiugrunk
 	            ' 100 x 0.0001 = 0,01, azaz egy szzadmsodperc eltelt!
        tiktak = 0  ' kezdjk ellrl a szmolst	
          
        BILLTIME = 1			
        SZMP = SZMP + 1  ' Szmoljuk a szzadmsodperceket
      If SZMP < 100 Then timerexit 'Ha mg nem rtk el a 100-at, kiugrunk  
        SZMP = 0    ' ha megvolt a 100 szzadmsodperc, kezdjk nulltl jra a szmllst, 
        MP = MP + 1 ' s nveljk a msodpercek szmt       
        MPBIT = 1   ' van egy "eltelt egy msodperc" jelz bitnk, azt is bebillentjk
        TOGGLE PORTA.4 ' tkapcsoljuk a LED llapott.
      If MP < 60 Then timerexit 'Ha mg nem rtk el a 100-at, kiugrunk  
        MP = 0    ' ha megvolt a 60 msodperc, kezdjk nulltl jra a szmllst, 
        PERC = PERC + 1 ' s nveljk a percek szmt       
        PERCBIT = 1   ' van egy "eltelt egy perc" jelz bitnk, azt is bebillentjk                

    timerexit: 
'        INTCON.2 = 0    ' Reseteljk a timer0 "tlcsorduls" megszakts jelz bitet
        Resume
    
    END				' Itt a progi vege. 	
